<?php

function cngeoip_lookup_ip($ip) {
    $CNGEOIP['RUS']=array(
    'AU'=>'Австралия',
    'AT'=>'Австрия',
    'AZ'=>'Азербайджан',
    'AX'=>'Аландские острова',
    'AL'=>'Албания',
    'DZ'=>'Алжир',
    'UM'=>'Внешние малые острова (США)',
    'VI'=>'Американские Виргинские острова',
    'AS'=>'Американское Самоа',
    'AI'=>'Ангилья',
    'AO'=>'Ангола',
    'AD'=>'Андорра',
    'AQ'=>'Антарктида',
    'AG'=>'Антигуа и Барбуда',
    'AR'=>'Аргентина',
    'AM'=>'Армения',
    'AW'=>'Аруба',
    'AF'=>'Афганистан',
    'BS'=>'Багамы',
    'BD'=>'Бангладеш',
    'BB'=>'Барбадос',
    'BH'=>'Бахрейн',
    'BZ'=>'Белиз',
    'BY'=>'Белоруссия',
    'BE'=>'Бельгия',
    'BJ'=>'Бенин',
    'BM'=>'Бермуды',
    'BG'=>'Болгария',
    'BO'=>'Боливия',
    'BA'=>'Босния и Герцеговина',
    'BW'=>'Ботсвана',
    'BR'=>'Бразилия',
    'IO'=>'Британские территории Индийского океана',
    'VG'=>'Британские Виргинские острова',
    'BN'=>'Бруней',
    'BF'=>'Буркина Фасо',
    'BI'=>'Бурунди',
    'BT'=>'Бутан',
    'VU'=>'Вануату',
    'VA'=>'Ватикан',
    'GB'=>'Великобритания',
    'HU'=>'Венгрия',
    'VE'=>'Венесуэла',
    'TL'=>'Восточный Тимор',
    'VN'=>'Вьетнам',
    'GA'=>'Габон',
    'HT'=>'Гаити',
    'GY'=>'Гайана',
    'GM'=>'Гамбия',
    'GH'=>'Гана',
    'GP'=>'Гваделупа',
    'GT'=>'Гватемала',
    'GN'=>'Гвинея',
    'GW'=>'Гвинея-Бисау',
    'DE'=>'Германия',
    'GI'=>'Гибралтар',
    'HN'=>'Гондурас',
    'HK'=>'Гонконг',
    'GD'=>'Гренада',
    'GL'=>'Гренландия',
    'GR'=>'Греция',
    'GE'=>'Грузия',
    'GU'=>'Гуам',
    'DK'=>'Дания',
    'CD'=>'Демократическая Республика Конго',
    'DJ'=>'Джибути',
    'DM'=>'Доминика',
    'DO'=>'Доминиканская республика',
    'EU'=>'Европейский Союз',
    'EG'=>'Египет',
    'ZM'=>'Замбия',
    'EH'=>'Западная Сахара',
    'ZW'=>'Зимбабве',
    'IL'=>'Израиль',
    'IN'=>'Индия',
    'ID'=>'Индонезия',
    'JO'=>'Иордания',
    'IQ'=>'Ирак',
    'IR'=>'Иран',
    'IE'=>'Ирландия',
    'IS'=>'Исландия',
    'ES'=>'Испания',
    'IT'=>'Италия',
    'YE'=>'Йемен',
    'KP'=>'КНДР',
    'CV'=>'Кабо-Верде',
    'KZ'=>'Казахстан',
    'KY'=>'Каймановы острова',
    'KH'=>'Камбоджа',
    'CM'=>'Камерун',
    'CA'=>'Канада',
    'QA'=>'Катар',
    'KE'=>'Кения',
    'CY'=>'Кипр',
    'KG'=>'Киргизстан',
    'KI'=>'Кирибати',
    'CN'=>'Китайская Народная Республика',
    'CC'=>'Кокосовые острова',
    'CO'=>'Колумбия',
    'KM'=>'Коморские острова',
    'CR'=>'Коста-Рика',
    'CI'=>'Кот-д’Ивуар',
    'CU'=>'Куба',
    'KW'=>'Кувейт',
    'LA'=>'Лаос',
    'LV'=>'Латвия',
    'LS'=>'Лесото',
    'LR'=>'Либерия',
    'LB'=>'Ливан',
    'LY'=>'Ливия',
    'LT'=>'Литва',
    'LI'=>'Лихтенштейн',
    'LU'=>'Люксембург',
    'MU'=>'Маврикий',
    'MR'=>'Мавритания',
    'MG'=>'Мадагаскар',
    'YT'=>'Майот',
    'MO'=>'Макао',
    'MK'=>'Македония',
    'MW'=>'Малави',
    'MY'=>'Малайзия',
    'ML'=>'Мали',
    'MV'=>'Мальдивы',
    'MT'=>'Мальта',
    'MA'=>'Марокко',
    'MQ'=>'Мартиника',
    'MH'=>'Маршалловы острова',
    'MX'=>'Мексика',
    'MZ'=>'Мозамбик',
    'MD'=>'Молдавия',
    'MC'=>'Монако',
    'MN'=>'Монголия',
    'MS'=>'Монсеррат',
    'MM'=>'Мьянма',
    'NA'=>'Намибия',
    'NR'=>'Науру',
    'NP'=>'Непал',
    'NE'=>'Нигер',
    'NG'=>'Нигерия',
    'AN'=>'Нидерландские Антильские острова',
    'NL'=>'Нидерланды',
    'NI'=>'Никарагуа',
    'NU'=>'Ниуэ',
    'NC'=>'Новая Каледония',
    'NZ'=>'Новая Зеландия',
    'NO'=>'Норвегия',
    'AE'=>'Объединённые Арабские Эмираты',
    'OM'=>'Оман',
    'CX'=>'Остров Рождества',
    'CK'=>'Острова Кука',
    'HM'=>'Острова Хирд и Макдональд',
    'PK'=>'Пакистан',
    'PW'=>'Палау',
    'PS'=>'Палестинская автономия',
    'PA'=>'Панама',
    'PG'=>'Папуа-Новая Гвинея',
    'PY'=>'Парагвай',
    'PE'=>'Перу',
    'PN'=>'Питкэрн',
    'PL'=>'Польша',
    'PT'=>'Португалия',
    'PR'=>'Пуэрто-Рико',
    'CG'=>'Республика Конго',
    'RE'=>'Реюньон',
    'RU'=>'Россия',
    'RW'=>'Руанда',
    'RO'=>'Румыния',
    'US'=>'США',
    'SV'=>'Сальвадор',
    'WS'=>'Самоа',
    'SM'=>'Сан-Марино',
    'ST'=>'Сан-Томе и Принсипи',
    'SA'=>'Саудовская Аравия',
    'SZ'=>'Свазиленд',
    'SJ'=>'Свальбард и Ян Майен',
    'MP'=>'Северные Марианские острова',
    'SC'=>'Сейшелы',
    'SN'=>'Сенегал',
    'VC'=>'Сент-Винсент и Гренадины',
    'KN'=>'Сент-Китс и Невис',
    'LC'=>'Сент-Люсия',
    'PM'=>'Сент-Пьер и Микелон',
    'CS'=>'Сербия и Черногория',
    'SG'=>'Сингапур',
    'SY'=>'Сирия',
    'SK'=>'Словакия',
    'SI'=>'Словения',
    'SB'=>'Соломоновы острова',
    'SO'=>'Сомали',
    'SD'=>'Судан',
    'SR'=>'Суринам',
    'SL'=>'Сьерра-Леоне',
    'SU'=>'СССР',
    'TJ'=>'Таджикистан',
    'TH'=>'Таиланд',
    'TW'=>'Тайвань',
    'TZ'=>'Танзания',
    'TG'=>'Того',
    'TK'=>'Токелау',
    'TO'=>'Тонга',
    'TT'=>'Тринидад и Тобаго',
    'TV'=>'Тувалу',
    'TN'=>'Тунис',
    'TM'=>'Туркменистан',
    'TR'=>'Турция',
    'UG'=>'Уганда',
    'UZ'=>'Узбекистан',
    'UA'=>'Украина',
    'UY'=>'Уругвай',
    'FO'=>'Фарерские острова',
    'FM'=>'Федеративные Штаты Микронезии',
    'FJ'=>'Фиджи',
    'PH'=>'Филиппины',
    'FI'=>'Финляндия',
    'FK'=>'Фолклендские острова',
    'FR'=>'Франция',
    'GF'=>'Французская Гвиана',
    'PF'=>'Французская Полинезия',
    'TF'=>'Французские Южные территории',
    'HR'=>'Хорватия',
    'CF'=>'Центрально-Африканская Республика',
    'TD'=>'Чад',
    'CZ'=>'Чехия',
    'CL'=>'Чили',
    'CH'=>'Швейцария',
    'SE'=>'Швеция',
    'LK'=>'Шри-Ланка',
    'EC'=>'Эквадор',
    'GQ'=>'Экваториальная Гвинея',
    'ER'=>'Эритрея',
    'EE'=>'Эстония',
    'ET'=>'Эфиопия',
    'ZA'=>'ЮАР',
    'KR'=>'Южная Корея',
    'GS'=>'Южная Георгия и Южные Сандвичевы острова',
    'JM'=>'Ямайка',
    'JP'=>'Япония',
    'BV'=>'остров Буве',
    'NF'=>'остров Норфолк',
    'SH'=>'остров Святой Елены',
    'TC'=>'острова Тёркс и Кайкос',
    'WF'=>'острова Уоллис и Футура');

    $CNGEOIP['ENG']=array(
    'AD'=>'Andorra',
    'AE'=>'United Arab Emirates',
    'AF'=>'Afghanistan',
    'AG'=>'Antigua and Barbuda',
    'AI'=>'Anguilla',
    'AL'=>'Albania',
    'AM'=>'Armenia',
    'AN'=>'Netherlands Antilles',
    'AO'=>'Angola',
    'AQ'=>'Antarctica',
    'AR'=>'Argentina',
    'AS'=>'American Samoa',
    'AT'=>'Austria',
    'AU'=>'Australia',
    'AW'=>'Aruba',
    'AX'=>'Åland Islands',
    'AZ'=>'Azerbaijan',
    'BA'=>'Bosnia and Herzegovina',
    'BB'=>'Barbados',
    'BD'=>'Bangladesh',
    'BE'=>'Belgium',
    'BF'=>'Burkina Faso',
    'BG'=>'Bulgaria',
    'BH'=>'Bahrain',
    'BI'=>'Burundi',
    'BJ'=>'Benin',
    'BM'=>'Bermuda',
    'BN'=>'Brunei Darussalam',
    'BO'=>'Bolivia',
    'BR'=>'Brazil',
    'BS'=>'Bahamas',
    'BT'=>'Bhutan',
    'BV'=>'Bouvet Island',
    'BW'=>'Botswana',
    'BY'=>'Belarus',
    'BZ'=>'Belize',
    'CA'=>'Canada',
    'CC'=>'Cocos (Keeling) Islands',
    'CD'=>'Congo, the Democratic Republic of the',
    'CF'=>'Central African Republic',
    'CG'=>'Congo',
    'CH'=>'Switzerland',
    'CI'=>'Côte d\'Ivoire',
    'CK'=>'Cook Islands',
    'CL'=>'Chile',
    'CM'=>'Cameroon',
    'CN'=>'China',
    'CO'=>'Colombia',
    'CR'=>'Costa Rica',
    'CU'=>'Cuba',
    'CV'=>'Cape Verde',
    'CX'=>'Christmas Island',
    'CY'=>'Cyprus',
    'CZ'=>'Czech Republic',
    'DE'=>'Germany',
    'DJ'=>'Djibouti',
    'DK'=>'Denmark',
    'DM'=>'Dominica',
    'DO'=>'Dominican Republic',
    'DZ'=>'Algeria',
    'EC'=>'Ecuador',
    'EE'=>'Estonia',
    'EG'=>'Egypt',
    'EH'=>'Western Sahara',
    'ER'=>'Eritrea',
    'ES'=>'Spain',
    'ET'=>'Ethiopia',
    'FI'=>'Finland',
    'FJ'=>'Fiji',
    'FK'=>'Falkland Islands (Malvinas)',
    'FM'=>'Micronesia, Federated States of',
    'FO'=>'Faroe Islands',
    'FR'=>'France',
    'GA'=>'Gabon',
    'GB'=>'United Kingdom',
    'GD'=>'Grenada',
    'GE'=>'Georgia',
    'GF'=>'French Guiana',
    'GG'=>'Guernsey',
    'GH'=>'Ghana',
    'GI'=>'Gibraltar',
    'GL'=>'Greenland',
    'GM'=>'Gambia',
    'GN'=>'Guinea',
    'GP'=>'Guadeloupe',
    'GQ'=>'Equatorial Guinea',
    'GR'=>'Greece',
    'GS'=>'South Georgia and the South Sandwich Islands',
    'GT'=>'Guatemala',
    'GU'=>'Guam',
    'GW'=>'Guinea-Bissau',
    'GY'=>'Guyana',
    'HK'=>'Hong Kong',
    'HM'=>'Heard Island and McDonald Islands',
    'HN'=>'Honduras',
    'HR'=>'Croatia',
    'HT'=>'Haiti',
    'HU'=>'Hungary',
    'ID'=>'Indonesia',
    'IE'=>'Ireland',
    'IL'=>'Israel',
    'IM'=>'Isle of Man',
    'IN'=>'India',
    'IO'=>'British Indian Ocean Territory',
    'IQ'=>'Iraq',
    'IR'=>'Iran, Islamic Republic of',
    'IS'=>'Iceland',
    'IT'=>'Italy',
    'JE'=>'Jersey',
    'JM'=>'Jamaica',
    'JO'=>'Jordan',
    'JP'=>'Japan',
    'KE'=>'Kenya',
    'KG'=>'Kyrgyzstan',
    'KH'=>'Cambodia',
    'KI'=>'Kiribati',
    'KM'=>'Comoros',
    'KN'=>'Saint Kitts and Nevis',
    'KP'=>'Korea, Democratic People\'s Republic of',
    'KR'=>'Korea, Republic of',
    'KW'=>'Kuwait',
    'KY'=>'Cayman Islands',
    'KZ'=>'Kazakhstan',
    'LA'=>'Lao People\'s Democratic Republic',
    'LB'=>'Lebanon',
    'LC'=>'Saint Lucia',
    'LI'=>'Liechtenstein',
    'LK'=>'Sri Lanka',
    'LR'=>'Liberia',
    'LS'=>'Lesotho',
    'LT'=>'Lithuania',
    'LU'=>'Luxembourg',
    'LV'=>'Latvia',
    'LY'=>'Libyan Arab Jamahiriya',
    'MA'=>'Morocco',
    'MC'=>'Monaco',
    'MD'=>'Moldova, Republic of',
    'ME'=>'Montenegro',
    'MG'=>'Madagascar',
    'MH'=>'Marshall Islands',
    'MK'=>'Macedonia, the former Yugoslav Republic of',
    'ML'=>'Mali',
    'MM'=>'Myanmar',
    'MN'=>'Mongolia',
    'MO'=>'Macao',
    'MP'=>'Northern Mariana Islands',
    'MQ'=>'Martinique',
    'MR'=>'Mauritania',
    'MS'=>'Montserrat',
    'MT'=>'Malta',
    'MU'=>'Mauritius',
    'MV'=>'Maldives',
    'MW'=>'Malawi',
    'MX'=>'Mexico',
    'MY'=>'Malaysia',
    'MZ'=>'Mozambique',
    'NA'=>'Namibia',
    'NC'=>'New Caledonia',
    'NE'=>'Niger',
    'NF'=>'Norfolk Island',
    'NG'=>'Nigeria',
    'NI'=>'Nicaragua',
    'NL'=>'Netherlands',
    'NO'=>'Norway',
    'NP'=>'Nepal',
    'NR'=>'Nauru',
    'NU'=>'Niue',
    'NZ'=>'New Zealand',
    'OM'=>'Oman',
    'PA'=>'Panama',
    'PE'=>'Peru',
    'PF'=>'French Polynesia',
    'PG'=>'Papua New Guinea',
    'PH'=>'Philippines',
    'PK'=>'Pakistan',
    'PL'=>'Poland',
    'PM'=>'Saint Pierre and Miquelon',
    'PN'=>'Pitcairn',
    'PR'=>'Puerto Rico',
    'PS'=>'Palestinian Territory, Occupied',
    'PT'=>'Portugal',
    'PW'=>'Palau',
    'PY'=>'Paraguay',
    'QA'=>'Qatar',
    'RE'=>'Réunion',
    'RO'=>'Romania',
    'RS'=>'Serbia',
    'RU'=>'Russian Federation',
    'RW'=>'Rwanda',
    'SA'=>'Saudi Arabia',
    'SB'=>'Solomon Islands',
    'SC'=>'Seychelles',
    'SD'=>'Sudan',
    'SE'=>'Sweden',
    'SG'=>'Singapore',
    'SH'=>'Saint Helena',
    'SI'=>'Slovenia',
    'SJ'=>'Svalbard and Jan Mayen',
    'SK'=>'Slovakia',
    'SL'=>'Sierra Leone',
    'SM'=>'San Marino',
    'SN'=>'Senegal',
    'SO'=>'Somalia',
    'SR'=>'Suriname',
    'ST'=>'Sao Tome and Principe',
    'SV'=>'El Salvador',
    'SY'=>'Syrian Arab Republic',
    'SZ'=>'Swaziland',
    'TC'=>'Turks and Caicos Islands',
    'TD'=>'Chad',
    'TF'=>'French Southern Territories',
    'TG'=>'Togo',
    'TH'=>'Thailand',
    'TJ'=>'Tajikistan',
    'TK'=>'Tokelau',
    'TL'=>'Timor-Leste',
    'TM'=>'Turkmenistan',
    'TN'=>'Tunisia',
    'TO'=>'Tonga',
    'TR'=>'Turkey',
    'TT'=>'Trinidad and Tobago',
    'TV'=>'Tuvalu',
    'TW'=>'Taiwan, Province of China',
    'TZ'=>'Tanzania, United Republic of',
    'UA'=>'Ukraine',
    'UG'=>'Uganda',
    'UM'=>'United States Minor Outlying Islands',
    'US'=>'United States',
    'UY'=>'Uruguay',
    'UZ'=>'Uzbekistan',
    'VA'=>'Holy See (Vatican City State)',
    'VC'=>'Saint Vincent and the Grenadines',
    'VE'=>'Venezuela',
    'VG'=>'Virgin Islands, British',
    'VI'=>'Virgin Islands, U.S.',
    'VN'=>'Viet Nam',
    'VU'=>'Vanuatu',
    'WF'=>'Wallis and Futuna',
    'WS'=>'Samoa',
    'YE'=>'Yemen',
    'YT'=>'Mayotte',
    'ZA'=>'South Africa',
    'ZM'=>'Zambia',
    'ZW'=>'Zimbabwe');

    if ( ereg("^([0-9]{1,3})\.([0-9]{1,3})\.([0-9]{1,3})\.([0-9]{1,3})$", $ip, $res) ) {
	if ( $res[1] > 255 || $res[2] > 255 || $res[3] > 255 || $res[4] > 255) return Array();
    } else
	return Array();
    $ipint = ($res[1]<<24) + ($res[2]<<16) + ($res[3]<<8) + $res[4];
    $LEVEL_SIZE = array(8,8,4,4,3,3,2,0);
    $first_xor_code = 1;
    for($i=0,$left=32;$i<sizeof($LEVEL_SIZE);$i++) {
	$first_xor_code <<= $LEVEL_SIZE[$i];
	$first_xor_code += $left;
	$first_xor_code = (($first_xor_code >> 11) & 0x001fffff) + ( $first_xor_code << 11);
	$left -= $LEVEL_SIZE[$i];
    }
    $FP = fopen(dirname(__FILE__)."/cngeoip.dat", "r");
    if ( !$FP )
	return Array();
    $shift = 32;
    $offset = 0;
    for($l=0; $l<sizeof($LEVEL_SIZE); $l++) {
	$shift -= $LEVEL_SIZE[$l];
	$index = (($ipint>>$shift)) & ((1<<$LEVEL_SIZE[$l])-1);
	$tell = $offset+$index*4;
	fseek($FP, $tell, 0);
	$data = fread($FP, 4);
	$unp = unpack('Vdata',$data);
	$offset = $unp['data'] ^ $first_xor_code ^ $tell;
	$offset &= 0xffffffff;
	if ( $offset & 0x80000000 ) {
	    $tell = $offset & 0x7fffffff;
	    fseek($FP, $tell, 0);
	    $data = fread($FP, 2);
	    $unp = unpack('vlen', $data);
	    $length = ( $unp['len'] ^ $first_xor_code ^ $tell ) &0xffff;
	    $tell += 2;
	    if ( $length > 0 ) {
		$info = fread($FP, $length);
		$xor = $tell ^ $first_xor_code;
		for($i=0,$s=strlen($info),$res=""; $i<$s; $i++) {
		    $res .= chr((ord(substr($info,$i,1)) ^ $xor) & 0xff );
		    $xor = ( ($xor >> 3) &0x1fffffff) ^ ( ($xor & 0x1fffffff) << 3);
		}
		$info = $res;
	    }
	    else
		$info = "";
	    break;
	}
    }
    fclose($FP);
    $result_array = explode("/",$info);
    $result_array[7] = @$result_array[5];
    $result_array[8] = @$result_array[6];
    $result_array[5] = @$CNGEOIP['RUS'][@$result_array[2]];
    $result_array[6] = @$CNGEOIP['ENG'][@$result_array[2]];
    return $result_array;
}


function cngeoip_lookup_ip_cp1251($ip) {
    $result_array = cngeoip_lookup_ip($ip);
    for($i=0,$s=sizeof($result_array);$i<$s;$i++)
	$result_array[$i] = cngeoip_unUTF(@$result_array[$i]);
    return $result_array;
}


function cngeoip_unUTF($str) {
    $newstr="";
    $l=strlen($str);
    $i=0;
    while ($i<$l) {
         $code=ord($str[$i]);
         if ($code<0x80) $newstr.=$str[$i];
         else {
              $i++;
              $w=$code*256+ord($str[$i]);

              if ($w>=0xd090) $b=192+$w-0xd090; else $b=95;
              if ($w>=0xd180 && $w<=0xd18f) $b=240+$w-0xd180;
              $newstr.=chr($b);
              }
         $i++;
         }
    return($newstr);
}



?>